!  891
! BBS Lister by  Doogie.
!
! I make no guarantees about this script.  It works here, it might not for
! you.  If you have questions, I can be reached at the following places.
!
! Doogie@1517005        VirtualNET
! Doogie@131            InterGATE
! Doogie@shianet.org    Internet        --- Prefered
! Doogie@virtualc.com   Internet
!
! This script lists BBS'es(Duh!).  It stores the BBS name, SysOp name,
! three lines of descriptions, a variable number of networks, and a
! variable number of phone lines for each BBS.  For each network, the node
! address is stored, and for each phone line, the modem speed is saved.
!
! Normally, when viewing the list, each BBS record is shown in the short
! form.  Hitting 'V' and entering the line to view, will show the extended
! description for the record.
!
! Main Menu Options
!
! L       List the BBS'es.  Only if BBSES2.LST exists.   
! D       Download the BBS list.  Only if BBSES2.LST exists.
! H       Online Help.
! Q       Quit the script.
! ?       Relist the menu.
! V       Validate new BBS'es.  Only if $security >= $sysopsec.
! A       Add a new BBS.  Only if  $security >= $bbsadd.
!         If $security < $sysopsec, then an email will be sent to the
!         users who's number is stored in $notifyuser.
!
! List prompt
!
! C       Continue listing BBS'es.  If there are none, then return to the
!         Main Menu.
! V       View Extended screen.  Will prompt for which line to view.  
! E       Edit record.  Will prompt for which line to edit.
!         Only if $security >= $sysopsec.
! R       Remove record.  Will prompt for which line to remove.  After
!         removing, it will read in another line. 
!         Only if $security >= $sysopsec. 
! Q       Quit listing BBS'es.
! A       Only dipsplayed when validating new BBS'es.  Will move a record
!         from the validation file, to the regular file for viewing by
!         others.
!
! Edit Menu
!
! O       View Old BBS record.
! N       View New BBS record.
! B       Change the BBS name.
! S       Change the SysOp Name.
! D       Change the description.
! K       Edit the networks.
! P       Edit the phone lines.
! Q       Quit back to List Prompt
! V       Save the current changes.  Asks for confirmation.  After saving,
!         it returns to the List Prompt.
! R       Remove the current record.  Asks for confirmation.  After
!         removing it returns to the List Prompt.
! ?       Redisplay this menu.
!
! The menus and prompts in this script automatically adjust to fit the
! current situation.  Ie, if there are no BBS'es in the file, then there
! will be no option to List the BBS'es or to Download the list.
!
! Likewise, if there are no BBS'es to be validated, then this option will
! not appear.
!
! These eight lines need to be placed in TXT\BBSLST.CFG.
!
! $bbsadd       Security level needed to add a BBS to the list.
! $sysopsec     Security level needed to access SysOp functions.
! $pausestr     String to display when pausing.  Do NOT include color.
! $bbsver       Set to 7.0 to use animated pause.  Anything else uses
!               6.x compatible pausing.
! $notifyuser   User to send an email to when adding a new BBS.  If a SysOp
!               adds a BBS, then an email is NOT sent.
! $exitfb       Set this to the function block you want it to exit to.  For
!               version 7.x, if blank it will return to the FB it was called
!               from.
! $bbsfile      File to store the BBS'es in.  This is placed in your text
!               directory.
! $bbsrevfile   Where to store the BBS'es waiting to be reviewed.  Again,
!               this is placed in your text directory.
!

$bbsf = $textpath & "BBSLST.cfg"
open $bbsf input
read $bbsadd
read $sysopsec
read $pausestr
read $bbsver
read $notifyuser
read $exitfb
read $bbsfile
read $bbsrevfile
close

$bbsfile = $textpath & $bbsfile
$bbsrevfile = $textpath & $bbsrevfile
suspendpagebreak
action "BBS Lister Version 2.0"
$tempfile = "b" & $port & ".tmp"
$tempbackfile = "b" & $port & ".bak"
$temprevfile = "b" & $port & ".rev"
$f = "b" & $port & ".*"
findfirst $s $f
$l = $s len 0
ifval $l > 0
  $s = "del b" & $port & ".* >nul"
  shell $s
endif

$clrscrncmd = "ts"
if $ansi = "OFF"
  $clrscrncmd = "tr"
endif


# mainmenu
  buffer clear
  $keys = "QH?"
  tr
  checkfile $s $bbsfile
  ifval $s > 10
    tr "7(2L7) 5L6ist BBS'es" $crlf "7(2D7) 5D6ownload BBS List"
    $keys = "LD" & $keys
  endif
  tr "7(2H7) 5H6elp" $crlf "7(2Q7) 5Q6uit" $crlf "7(2?7) 6Relist Menu"
  ifval $security >= $sysopsec
    checkfile $s $bbsrevfile
    ifval $s > 0
      tr "7(2V7) 5V6alidate New BBS'es"
      $keys = $keys & "V"
    endif
  endif
  ifval $security >= $bbsadd
    tr "7(2A7) 5A6dd BBS"
    $keys = $keys & "A"
  endif


# endmenu
  call menuprompt
  test $answer = "?" mainmenu

  if $answer = "A"
    link bbsadd
  endif

  if $answer = "L"
    $listfile = $bbsfile
    $listmode = ""
  endif
  test $answer = "L" listbbses

  if $answer = "D"
    link downbbs
  endif

  if $answer = "V"
    $listfile = $bbsrevfile
    $listmode = "REVIEW"
  endif
  test $answer = "V" listbbses
  if $answer = "H"

    $helpfile = "BBSLMAIN.HLP"
    call displayhelp
  endif
  test $answer = "H" mainmenu


  go alldone

# alldone
  tr $crlf "0This is a script by" $crlf
  tr "1 7 9 1 7 9"
  tr "1    7    9    1  7     9  "
  tr "1  7   9   1   7 9" $crlf
  tr "1D9o7o1g9i7e6@51517005        BVirtualNET"
  tr "1D9o7o1g9i7e6@5131            :InterGATE"
  tr "1D9o7o1g9i7e6@5shianet.org    BInternet"
  tr "1D9o7o1g9i7e6@51              :ShiaCliNet"
  tr "1D9o7o1g9i7e6@51517000        BVPINet" $crlf
  
  call pausestr
  resumepagebreak
  exit $exitfb
# listbbses
  checkfile $s $listfile
  ifval $s = 0
    tr
    $s = "I don't know of any BBSes.  Maybe you could add some?"
    call slide
    tr $crlf
  endif
  testval $s = 0 listbbsend
  ifval $security >= $sysopsec
    $listkeys = "CVEQR" & $cr
    $pr = "5C1oAntinue6/5V1iAew Extended6/5E1dAit6/5R1eAmove6/5Q1uAit 6[5C1oAntinue     6]"

  else
    $listkeys = "CVQ" & $cr
    $pr = "5C1oAntinue6/5V1iAew Extended6/5Q1uAit 6[5C1oAntinue     6]"
  endif
  if $listmode = "REVIEW"
    $listkeys = "CAQRVE" & $cr
    $pr = "5C1oAntinue6/5V1iAew Extended6/5E1dAit6/5A1pAprove6/5R1eAmove6/5Q1uAit 6[5C1oAntinue     6]"
  endif
  $prb = $bs
  do $a = 1 13
    $prb = $prb & $bs
  loop

  buffer clear
  open $listfile input
  if $listmode <> "REVIEW"
    read $bbsfilever
    buffer append $bbsfilever
  endif


# listbbstop

  $num = 0
  read $line1
  if $line1 = "!EOF!"
    tr
    $s = "5T1hAat's 5i1tA.  5N1o 5m1oAre 5B1BAS'es!"
    call slide
    tr
    call pausestr
  endif
  test $line1 = "!EOF!" listbbsend
  $num = 1

# listline2
  read $line2
  test $line2 = "!EOF!" listdonereading
  $num = 2

# listline3
  read $line3
  test $line3 = "!EOF!" listdonereading
  $num = 3

# listline4
  read $line4
  test $line4 = "!EOF!" listdonereading
  $num = 4

# listdonereading
  testval $num = 0 listbbsend
  ifval $num > 0
    call displayshrtheader
    
    $linetxt = $line1
    $pl = 1
    call displayshrt
  endif
  ifval $num > 1
    
    $linetxt = $line2
    $pl = 2
    call displayshrt

  endif
  ifval $num > 2
    
    $linetxt = $line3
    $pl = 3
    call displayshrt

  endif
  ifval $num > 3
    
    $linetxt = $line4
    $pl = 4
    call displayshrt

  endif
  ts "5"
  
  $s = $pr
  call slide
  ts $prb
  rr $key $listkeys

  if $key = $cr
    $key = "C"
  else
    ts $bs "5" $key
  endif

  if $key = "C"
    call continueproc
  endif

  
  test $key = "C" listbbstop
  
  if $key = "V"
    tr "1iAew Extended6]"
    call viewextendedprompt
  endif
  
  if $key = "E"
    tr "1dAit         6]"
    call editbbsprompt
  endif

  if $key = "A"
    tr "1dAd          6]"
    call addprompt
  endif

  if $key = "R"
    tr "1eAmove       6]"
    call removeprompt
  endif

  test $key <> "Q" listdonereading
  tr "1uAit         6]"


# listbbsend
  call continueproc
  call read2buffer
  close
  if $listmode = "REVIEW"
    call a5
  else
    call a6
  endif

  go mainmenu
# a5
  checkfile $s $tempfile
  ifval $s > 0
    $s = "copy " & $tempfile & " " 
    $s = $s & $bbsrevfile & " >nul"
  else
    $s = "del " & $bbsrevfile & " >nul"
  endif
  shell $s
  buffer clear
  
  ret

# a6
  checkfile $s $tempfile
  ifval $s > 0
    $s = "copy " & $tempfile & " "
    $s = $s & $bbsfile & " > nul"
    shell $s
    buffer clear
  endif
  ret

# read2buffer

  read $readline
  test $readline = "!EOF!" read2bufferend
  buffer append $readline
  go read2buffer
  close
# read2bufferend
  ret

# displayshrtheader
  $clrscrncmd $clear
  ts "5Ŀ1BBS Name                                       52Sysop Name                    5Ĵ3Network Name                  56Node                        57Phone Number58Speed5Ĵ"
  ret
# displayshrt
  call extractline
  ts "51" $bname "52" $bbssysop "5"
  $j = "ô B" & $pl & " 5"
  ts $j "5Ĵ"

  $p = 0
  ifval $numnets > 0
    $r = $nets left 30
    $t = "53" & $r & "56"
    $r = $nets mid 31 left 28
    ts $t $r
  else
    ts "53  56  "
  endif
  ifval $numfons > 0
    $r = $fons left 12
    $u = "57" & $r & "58"
    $r = $fons mid 13 left 5
    ts $u $r "5"
  else
    ts "57  58  5"
  endif
  ifval $num <> $pl
    ts "5Ĵ"
  endif
  ret

# continueproc
  if $listmode = "REVIEW"
    checkfile $s1 $tempfile
    ifval $s1 > 0
      $s = "copy " & $tempfile & " "
      $s = $s & $tempbackfile & " >nul"
      shell $s
    endif
  endif
  ifval $num > 0
    buffer append $line1
  endif
  ifval $num > 1
    buffer append $line2
  endif
  ifval $num > 2
    buffer append $line3
  endif
  ifval $num > 3
    buffer append $line4
  endif
      
  if $listmode = "REVIEW"
    ifval $s1 > 0
      $s = "copy " & $tempbackfile & " "
      $s = $s & $tempfile & " >nul"
      shell $s
    endif

  endif

  ret

# viewextendedprompt
  call whichline
  
  call pickit
  $linetxt = $ll


  ifval $answer > 0
    call displayextendedbbs
  endif
  
  ret

# pickit
  ifval $answer = 1
    $ll = $line1
  endif
  ifval $answer = 2
    $ll = $line2
  endif
  ifval $answer = 3
    $ll = $line3
  endif
  ifval $answer = 4
    $ll = $line4
  endif
  ret


# editbbsprompt
  call whichline
  test $answer = "Q" editbbspromptend
  call pickit
  $editline = $ll
  ifval $answer = 1
    call editbbs
    $line1 = $editline
  endif
  ifval $answer = 2
    call editbbs
    $line2 = $editline
  endif
  ifval $answer = 3
    call editbbs
    $line3 = $editline
  endif
  ifval $answer = 4
    call editbbs
    $line4 = $editline
  endif
  $l = $editline LEN 0
  ifval $l = 0
    call scanit
  endif
# editbbspromptend
  ret

# addprompt
  call whichline
  test $answer = "Q" addpromptend
  call scanit
  $s = "copy " & $tempfile & " "
  $s = $s & $tempbackfile & " >nul"
  shell $s

  buffer clear
  buffer append $l

  $s = "copy " & $bbsfile & "+"
  $s = $s & $tempfile & " "
  $s = $s & $bbsfile & " >nul"
  shell $s

  checkfile $s $tempbackfile
  ifval $s > 0

    $s = "copy " & $tempbackfile & " "
    $s = $s & $tempfile & " >nul"
  else
    $s = "del " & $tempfile & " > nul"
  endif
  shell $s

# addpromptend  
  ret

# scanit
  if $answer <> "Q"
    $num = $num - 1
  endif
  call pickit
  $l = $ll

  ifval $answer < "2"
    $line1 = $line2
  endif
  ifval $answer < "3"
    $line2 = $line3
  endif
  ifval $answer < "4"
    $line3 = $line4
  endif
  $linetxt = "!EOF!"
  ifval $answer > 0
    read $linetxt
  endif
  if $linetxt <> "!EOF!"
    $num = 4
  endif
  $line4 = $linetxt
  ret


# removeprompt
  call whichline
  call scanit
  ret

# whichline
  $p = "1234" left $num & "Q"
  $s = "5Which line? (Q to Quit)5 "
  call slide
  rr $answer $p 
  ts $bs "5" $answer
  if $answer = "Q"
    ts "1u5it"
  endif
  tr
  ret

# displayhelp
  $helpf = $textpath & $helpfile
  checkfile $helpss $helpf
  testval $helpss = 0 displayhelpend
  open $helpf input
  $helps = 0

# displayhelploop
  read $helpline
  test $helpline = "!EOF!" displayhelpend
  $helpt = $helpline left 1
  $helpline = $helpline mid 2
  $helpt2 = $helpline left 1
  $helpline = $helpline mid 2
  $helppp = 0
  if $helpt = "N"
    $helppp = 1
  endif
  if $helpt = "A"
    ifval $security >= $bbsadd
      $helppp = 1
    endif
  endif
  if $helpt = "S"
    ifval $security >= $sysopsec
      $helppp = 1
    endif
  endif
  if $helppp = 1
    $s = $helpline
    call slide
    tr
    $helps = $helps + 1
  endif
  if $helpt2 = "P"
    $helps = $page
  endif
  ifval $helps = $page
    call pausestr
    $helps = 0
  endif
  go displayhelploop



# displayhelpend
  ifval $helps <> 0
    call pausestr
  endif
  ifval $helpss > 0
    close
  else
    $s = $helpfile & " does not exist!"
    call slide
    tr
  endif
  ret

& exline
& pausestr
& displyex
& buildln
& strphrt
& editbbs
& bbsiadd
& bbsprmpt
& slide
